<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="form-group col-md-8" :class="{'has-error': this.errors_banks.name}">
                <label>Nome<b class="text-danger">*</b></label>
                <input type="text" class="form-control" v-model="formData.name">
                <label class="error" v-if="this.errors_banks.name">{{errors_banks.name[0]}}</label>
            </div>

            <div class="form-group col-md-4" :class="{'has-error': this.errors_banks.saldo}">
                <label>Saldo inicial<b class="text-danger">*</b></label>
                <div class="input-group">
                    <div class="input-group-addon">
                        R$
                    </div>
                    <money type="text" class="form-control" v-model="formData.saldo"/>
                </div>
                <label class="error" v-if="this.errors_banks.saldo">{{errors_banks.saldo[0]}}</label>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>
        </form>
    </div>
</template>

<script>
    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        name: '',
                        saldo: '',
                    }
                }
            }
        },
        data() {
            return {
                errors_banks: {
                    name: '',
                    saldo: '',
                }
            }
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            }
        },

        methods: {
            onSubmit() {
                const action = this.isUpdate ? 'updateBank' : 'storeBank'
                const msg = this.isUpdate ? 'Conta bancária editada com sucesso' :
                    'Cadastro de conta bancária feita com sucesso'
                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(msg)
                        this.resetFormData()
                        this.$router.push({name: 'banks'})
                    })
                    .catch((error) => {
                        this.errors_banks = error.response.data.errors
                    })
            },

            resetFormData() {
                this.formData = {
                    name: '',
                    saldo: ''
                }
            },

            backPage() {
                return this.$router.push({name: 'banks'})
            }
        }
    }
</script>